<?php
namespace FM\Controller;

use FM\Controller\FMCrud;
use Zeedhi\Framework\DTO;
use Zeedhi\Framework\DTO\Request;
use Zeedhi\Framework\DTO\Response;
use Zeedhi\Framework\DataSource\DataSet;
use FM\Service\FuncionariosHierarqService;
use FM\Traits\TResponse;

class FuncionariosHierarqController extends FMCrud {

    use TResponse;

    protected $dataSourceName = 'fcm_checklistagend';
    protected $FuncionariosHierarqService;
   
    public function __construct($crudService, $environment, FuncionariosHierarqService $FuncionariosHierarqService) {
        parent::__construct($crudService, $environment);
        $this->FuncionariosHierarqService = $FuncionariosHierarqService;
    }
    
    public function getHierarquiaFacilities(Request $request, Response $response) {
        try {
                $data = $this->FuncionariosHierarqService->getHierarquiaFacilities($request->getParameters());
                $this->sendResponse($data, 200);
            } catch (Exception $ex) {
                $this->sendResponse(['error' => $ex->getMessage(), 'code' => $ex->getCode()], 500);
            }
    }

}
?>