<?php

namespace FM\Factory;

use Doctrine\ORM\EntityManager;

class ApontamentoFactory {
    protected $connection;

    public function __construct(EntityManager $entityManager) {
        $this->connection = $entityManager->getConnection();
    }
    
    public function lastEntry($nr) {

        $sql = "SELECT DTHRENTRADA
                  FROM FCM_REGISTROHORAS
                  WHERE NRREGISTROHORAS = (SELECT MAX(NRREGISTROHORAS)
                                             FROM FCM_REGISTROHORAS RH
                                             JOIN FCM_APONTAMENTO AP
                                               ON AP.NRAPONTAMENTO = RH.NRAPONTAMENTO
                                            WHERE AP.CDOPERADOR = ".$nr."
                                            AND AP.IDFALTA = 'N')";

        $std = $this->connection->prepare($sql);
        $std->execute();
        return $std->fetchAll();
    }
    
    public function getTodayRegister($nr) {

      $sql = "SELECT COUNT(NRAPONTAMENTO) QTDAP
                FROM FCM_APONTAMENTO
               WHERE TRUNC(FCM_APONTAMENTO.DTAPONTAMENTO) = TRUNC(SYSDATE)
               AND CDOPERADOR = ".$nr;

        $std = $this->connection->prepare($sql);

        $std->execute();
        return $std->fetchAll();
    }

    public function getNRAP($nr) {

      $sql = "SELECT NRAPONTAMENTO
                FROM FCM_APONTAMENTO
                WHERE TRUNC(FCM_APONTAMENTO.DTAPONTAMENTO) = TRUNC(SYSDATE)
                AND CDOPERADOR = ".$nr;

        $std = $this->connection->prepare($sql);
        $std->execute();
        return $std->fetchAll();
    }


    public function insertNewAppointment($parametros) {

        $sqlAlter = "ALTER SESSION SET NLS_DATE_FORMAT = 'DD/MM/YYYY HH24:MI:SS'";

        $std = $this->connection->prepare($sqlAlter);
        $std->execute();

        $sql = "INSERT INTO FCM_APONTAMENTO (NRAPONTAMENTO, DTAPONTAMENTO, CDOPERADOR,
                  IDFALTA, IDAPURADO, IDATIVO, NRORG, DTINCLUSAO)
                  VALUES (:NRAPONTAMENTO, NVL(TO_CHAR(:DTAPONTAMENTO),SYSDATE), :CDOPERADOR, :IDFALTA, :IDAPURADO,
                   'S', :NRORG, SYSDATE)";

        $std = $this->connection->prepare($sql);
        $std->execute($parametros);
    }

    public function insertNewRegister($parametros) {

        $sqlAlter = "ALTER SESSION SET NLS_DATE_FORMAT = 'DD/MM/YYYY HH24:MI:SS'";

        $std = $this->connection->prepare($sqlAlter);
        $std->execute();

        $sql = "INSERT INTO FCM_REGISTROHORAS (NRREGISTROHORAS, NRAPONTAMENTO, DTHRENTRADA,
                  IDTIPORESGISTRO, HRTEMPOREGISTRO, DSOBSREGISTRO, IDALMOCO, DTHRSAIDA, NRORG, IDATIVO, DTINCLUSAO)
                  VALUES (:NRREGISTROHORAS, :NRAPONTAMENTO, TO_CHAR(:DTHRENTRADA), :IDTIPORESGISTRO, NVL(:HRTEMPOREGISTRO, ROUND(((TO_DATE(:DTHRSAIDA) - TO_DATE(:DATEENTRY))*24)*60 ,0)),
                  :DSOBSREGISTRO, :IDALMOCO, TO_CHAR(:DTHRSAIDA), :NRORG, 'S', SYSDATE)";

        $std = $this->connection->prepare($sql);
        $std->execute($parametros);
    }

    public function typeRegister($cdoperador) {

        $sql = " SELECT IDTIPORESGISTRO, NRAPONTAMENTO, RPAD(DTHRENTRADA,10) AS DTHRENTRADA
                  FROM FCM_REGISTROHORAS
                  WHERE NRREGISTROHORAS = (SELECT MAX(NRREGISTROHORAS)
                                             FROM FCM_REGISTROHORAS RH
                                             JOIN FCM_APONTAMENTO AP
                                               ON AP.NRAPONTAMENTO = RH.NRAPONTAMENTO
                                            WHERE AP.CDOPERADOR =".$cdoperador."
                                            AND AP.IDFALTA = 'N')";

        $std = $this->connection->prepare($sql);
        $std->execute();
        return $std->fetchAll();

    }

    public function optionLunch($nr) {

        $sql = "SELECT COUNT(NRREGISTROHORAS) AS QTDALMOCO
                  FROM FCM_REGISTROHORAS
                 WHERE NRREGISTROHORAS = (SELECT MAX(NRREGISTROHORAS)
                                           FROM FCM_REGISTROHORAS RH
                                           JOIN FCM_APONTAMENTO AP
                                                             ON AP.NRAPONTAMENTO = RH.NRAPONTAMENTO
                                                          WHERE AP.CDOPERADOR = ".$nr."
                                                          AND AP.IDFALTA = 'N'
                                                         AND RPAD(RH.DTHRSAIDA, 10) = TO_CHAR(SYSDATE, 'DD/MM/YYYY'))

                                 GROUP BY IDTIPORESGISTRO, IDALMOCO";

        $std = $this->connection->prepare($sql);
        $std->execute();
        return $std->fetchAll();

    }

    public function cardsRegisters($cdoperador) {

      $sql = "SELECT RH.NRREGISTROHORAS, RH.DTHRENTRADA, RH.DTHRSAIDA, RH.IDALMOCO,
                CASE RH.IDTIPORESGISTRO WHEN 'E' THEN 'Entrada'
                    WHEN 'S' THEN 'Saída'
                    ELSE NULL END AS IDTIPORESGISTRO
                FROM FCM_REGISTROHORAS RH
                JOIN FCM_APONTAMENTO AP
                  ON AP.NRAPONTAMENTO = RH.NRAPONTAMENTO
                 AND AP.CDOPERADOR = ".$cdoperador."
               WHERE RPAD(RH.DTHRENTRADA,10) = TO_CHAR(SYSDATE, 'DD/MM/YYYY')
                  OR RPAD(RH.DTHRSAIDA, 10) = TO_CHAR(SYSDATE, 'DD/MM/YYYY')";

      $std = $this->connection->prepare($sql);
      $std->execute();
      return $std->fetchAll();
    }
}

?>