<?php

namespace FM\Factory;

use Doctrine\ORM\EntityManager;

class FotoTarefaAgendFactory {
    protected $connection;

    public function __construct(EntityManager $entityManager) {
        $this->connection = $entityManager->getConnection();
    }
        
    public function salvarImagem($param) {
        $sql = "INSERT INTO FCM_FOTOTAREFAAGEND(NRFOTOTAREFAAGEND, NRTAREFAAGEND, DSFOTOTAREFAAGEND, IDATIVO, NRORG, DTINCLUSAO,
                                                CDOPERINCLUSAO, NRORGINCLUSAO, DTULTATU, CDOPERULTATU, NRORGULTATU, DSTYPE, NRSIZE)
                                         VALUES(:NRFOTOTAREFAAGEND, (SELECT MIN(NRTAREFAAGEND) AS NRTAREFAAGEND FROM FCM_TAREFAAGEND WHERE NRCHECKLISTAGEND = :NRTAREFAAGEND), :DSFOTOTAREFAAGEND, 'S', :NRORG, SYSDATE,
                                                :CDOPERINCLUSAO, :NRORGINCLUSAO, SYSDATE, :CDOPERULTATU, :NRORGULTATU, :DSTYPE,
                                                :NRSIZE)";
        
        $std = $this->connection->prepare($sql);
        $std->execute($param);
    }
        
    public function getFoto($param) {

        $sql = "SELECT NRFOTOTAREFAAGEND, DSFOTOTAREFAAGEND
                  FROM FCM_FOTOTAREFAAGEND
                 WHERE NRTAREFAAGEND = (SELECT MIN(NRTAREFAAGEND) AS NRTAREFAAGEND FROM FCM_TAREFAAGEND WHERE NRCHECKLISTAGEND = :NRTAREFAAGEND)";
        
        $std = $this->connection->prepare($sql);
        $std->execute($param);
        return $std->fetchAll();
    }
        
    public function deleteFoto($param) {

        $sql = "DELETE FROM FCM_FOTOTAREFAAGEND
                 WHERE NRFOTOTAREFAAGEND = :NRFOTOTAREFAAGEND
                   AND NRTAREFAAGEND = (SELECT MIN(NRTAREFAAGEND) AS NRTAREFAAGEND FROM FCM_TAREFAAGEND WHERE NRCHECKLISTAGEND = :NRTAREFAAGEND)";
        
        $std = $this->connection->prepare($sql);
        $std->execute($param);
    }
}

?>