<?php
namespace FM\Service;

use FM\Factory\FindFactory;
use Teknisa\Libs\Util\Environment;
use Teknisa\Libs\Util\NewCode;
use Zeedhi\Framework\DataSource\DataSet;

class FindService {

    protected $FindFactory;
    protected $Environment;
    protected $newCode;

    public function __construct (FindFactory $FindFactory, Environment $Environment, NewCode $newCode) {
        $this->FindFactory  = $FindFactory;
        $this->Environment               = $Environment;
        $this->newCode                   = $newCode;
    }

    public function findOperador($filtro) {
        $where = $this->montarFiltro($filtro);
        return $this->FindFactory->findOperador($where);
    }

    public function montarFiltro($find) {
        $operador = $this->Environment->getCdOperador();

        if(empty($find)){
            return ' 1 = 1';
        }
        $whereClause = [];
        foreach ($find as $column => $condition) {
            $operator = key($condition);
            $value = $condition[$operator];

            if($value === 'OPERADOR_LOGADO'){
                $value = $operador;
            }

            if (in_array($operator, ["IN", "NOT_IN"])) {
                $value = "($value)";
            } else {
                $value = "'$value'";
            }
        
            $whereClause[] = "$column $operator $value";
        }

        return " ".implode(" AND ", $whereClause);
    }
}
